﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Dim lblLon As Label
	Dim lblLat As Label
	Dim lblSpeed As Label
	Dim lblSatellites As Label
	Private lblGnssStatus As Label
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

Private Sub Button1_Click
	InitGps 'xui.MsgboxAsync("Hello world!", "B4X")
End Sub

private Sub InitGps
	
	If Starter.GNSS1.GPSEnabled = False Then
		ToastMessageShow("Please enable the GNSS device.", True)
		StartActivity(Starter.GNSS1.LocationSettingsIntent) 'Will open the relevant settings screen.
	Else
		Starter.rp.CheckAndRequest(Starter.rp.PERMISSION_ACCESS_FINE_LOCATION)
		
		Wait For Activity_PermissionResult (Permission As String, Resu As Boolean)

		If Resu Then
			Starter.StartGNSS 'CallSubDelayed(Starter, "StartGNSS")
		End If
	End If
End Sub

Public Sub GpsStatus (Satellites As List)
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("GPS Status:").Append(CRLF)
	Dim NumberOfSatellites As Int = Satellites.Size
	Dim Beidou, Galileo, Glonass, Gps, Other As List
	Beidou.Initialize
	Galileo.Initialize
	Glonass.Initialize
	Gps.Initialize
	Other.Initialize
	Dim usedinfix As Int = 0
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("GPS Status").Append(CRLF)
	For i = 0 To NumberOfSatellites - 1
		Dim gpsat As GPSSatellite = Satellites.Get(i)
		If gpsat.Prn > 300 Then
			Galileo.Add(i)
		Else If gpsat.Prn > 200 Then
			Beidou.Add(i)
		Else If gpsat.Prn > 64 Then
			Glonass.Add(i)
		Else
			Gps.Add(i)
		End If
		If gpsat.UsedInFix Then usedinfix = usedinfix + 1
	Next
	sb.Append($"Beidou ${Beidou.Size} : "$)
	For i = 0 To Beidou.Size -1
		Dim gpsat As GPSSatellite = Satellites.Get(Beidou.Get(i))
		sb.Append(gpsat.Prn).Append(" ")
	Next
	sb.Append(CRLF)
	
	sb.Append($"Galileo ${Galileo.Size} : "$)
	For i = 0 To Galileo.Size - 1
		Dim gpsat As GPSSatellite = Satellites.Get(Galileo.Get(i))
		sb.Append(gpsat.Prn).Append(" ")
	Next
	sb.Append(CRLF)
	
	sb.Append($"Glonass ${Glonass.Size} : "$)
	For i = 0 To Glonass.Size -1
		Dim gpsat As GPSSatellite = Satellites.Get(Glonass.Get(i))
		sb.Append(gpsat.Prn).Append(" ")
	Next
	sb.Append(CRLF)
	
	sb.Append($"Gps ${Gps.Size} : "$)
	For i = 0 To Gps.Size -1
		Dim gpsat As GPSSatellite = Satellites.Get(Gps.Get(i))
		sb.Append(gpsat.Prn).Append(" ")
	Next
	sb.Append(CRLF)
	sb.Append($"Satellites : ${NumberOfSatellites}"$).Append(CRLF)
	sb.Append($"Used in fix: ${usedinfix}"$).Append(CRLF)
	lblSatellites.Text = sb.ToString
End Sub

Public Sub GnssStatus (Status As GnssStatus)
	Dim NumberOfSatellites As Int = Status.SatelliteCount
	Dim Beidou, Galileo, Glonass, Gps, Other As List
	Beidou.Initialize
	Galileo.Initialize
	Glonass.Initialize
	Gps.Initialize
	Other.Initialize
	Dim usedinfix As Int = 0
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("GNSS Status").Append(CRLF)
	For i = 0 To NumberOfSatellites - 1
		Select Status.ConstellationType(i)
			Case Status.CONSTELLATION_BEIDOU
				Beidou.Add(i)
			Case Status.CONSTELLATION_GALILEO
				Galileo.Add(i)
			Case Status.CONSTELLATION_GLONASS
				Glonass.Add(i)
			Case Status.CONSTELLATION_GPS
				Gps.Add(i)
			Case Else
				Other.Add(i)
		End Select
		If Status.UsedInFix(i) Then usedinfix = usedinfix + 1
	Next
	sb.Append($"Beidou ${Beidou.Size} : "$)
	For i = 0 To Beidou.Size -1
		sb.Append(Status.Svid(Beidou.Get(i))).Append(" ")
	Next
	sb.Append(CRLF)
	
	sb.Append($"Galileo ${Galileo.Size} : "$)
	For i = 0 To Galileo.Size -1
		sb.Append(Status.Svid(Galileo.Get(i))).Append(" ")
	Next
	sb.Append(CRLF)
	
	sb.Append($"Glonass ${Glonass.Size} : "$)
	For i = 0 To Glonass.Size -1
		sb.Append(Status.Svid(Glonass.Get(i))).Append(" ")
	Next
	sb.Append(CRLF)
	
	sb.Append($"Gps ${Gps.Size} : "$)
	For i = 0 To Gps.Size -1
		sb.Append(Status.Svid(Gps.Get(i))).Append(" ")
	Next
	sb.Append(CRLF)
	
	sb.Append($"Others : ${Other.Size}"$).Append(CRLF)
	sb.Append($"Satellites : ${NumberOfSatellites}"$).Append(CRLF)
	sb.Append($"Used in fix: ${usedinfix}"$).Append(CRLF)
	lblGnssStatus.Text = sb.ToString
End Sub

Public Sub LocationChanged(Location1 As Location)
	lblLat.Text = "Lat = " & Location1.ConvertToMinutes(Location1.Latitude)
	lblLon.Text = "Lon = " & Location1.ConvertToMinutes(Location1.Longitude)
	lblSpeed.Text = $"Speed = $1.2{Location1.Speed} m/s "$
End Sub
